# Výpočet log_10 2 pomocí aproximací odmocniny

# n-tá odmocnina z a, l-tá iterace
def odmocnina(a,n,l):
    #první odhad odmocniny je celá část odmocniny
    k = int(a**(1/n))
    seznam_odmocnin = [k]
    for i in range(0, l+1):
        seznam_odmocnin += [(a+(n-1)*k**n) / (n*k**(n-1))]
        k = seznam_odmocnin[-1]
    return(seznam_odmocnin)


exponenty_odmocnin = [10, 10**3, 10**5, 10**7]


# odmocniny využijeme pro výpočet logaritmu o základu a čísla x 
def logaritmus(a, x):
    seznam_logaritmu = []
    for n in exponenty_odmocnin:
        odmocnina_dvou = odmocnina(x,n,5)[-1]
        odmocnina_deseti = odmocnina(a,n,10)[-1]
        seznam_logaritmu += [(odmocnina_dvou-1) / (odmocnina_deseti-1)]
    return(seznam_logaritmu)


# vypočítáme odmocniny pro exponenty ze seznamu
for n in exponenty_odmocnin:
    print("n =", n)
    seznam_odmocnin_10 = odmocnina(10,n,10)
    seznam_odmocnin_2 = odmocnina(2,n,4)
    print("odmocnina 10:", seznam_odmocnin_10)
    print("odmocnina 2:", seznam_odmocnin_2)
    print()

print("log 2:", logaritmus(10,2))
